Package: hystar
Title: Fit the Hysteretic Threshold Autoregressive Model
Version: 1.0.0
Date: 2023-07-03
Authors@R: c(
    person("Daan", "de Jong", 
           email = "daandejong94@gmail.com", 
           role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0001-6034-0136")),
    person("European Research Council", role = "fnd")
  )
Maintainer: Daan de Jong <daandejong94@gmail.com>
Description: Estimate parameters of the hysteretic threshold autoregressive
    (HysTAR) model, using conditional least squares.
    In addition, you can generate time series data from the HysTAR model.
    For details, see Li, Guan, Li and Yu (2015) <doi:10.1093/biomet/asv017>.
License: MIT + file LICENSE
URL: https://github.com/daandejongen/hystar/
BugReports: https://github.com/daandejongen/hystar/issues/
Imports: graphics, Rcpp, stats, utils
Suggests: testthat (>= 3.0.0)
LinkingTo: Rcpp
Encoding: UTF-8
RoxygenNote: 7.2.0
NeedsCompilation: yes
Packaged: 2023-07-03 11:16:05 UTC; daandejong
Author: Daan de Jong [aut, cre, cph] (<https://orcid.org/0000-0001-6034-0136>),
  European Research Council [fnd]
Repository: CRAN
Date/Publication: 2023-07-05 14:10:02 UTC
Built: R 4.4.0; aarch64-apple-darwin21.6.0; 2024-04-29 20:06:27 UTC; unix

test_that("lagged matrix is correct", {
  # Simple case
  y <- 1:6
  p0 <- 3
  p1 <- 1
  eff <- 4:6
  actual <- create_x(y, eff, p0, p1)

  expected <- matrix(c(1, 3, 2, 1,
                       1, 4, 3, 2,
                       1, 5, 4, 3),
                     nrow = 3, byrow = TRUE)
  expect_equal(actual, expected)
})

test_that("lagged matrix is also correct when p=0 and d=0", {
  expect_equal(create_x(y = 1:5, eff = 1:5, p0 = 0, p1 = 0),
               matrix(1, nrow = 5, ncol = 1))
})

test_that("X is correctly formed", {
  p0 <- 1
  p1 <- 2
  x <- create_x(y = 1:5, eff = 3:5, p0 = p0, p1 = p1)
  R <- c(0, 1, 0)
  X_true <- create_X(x = x, p0 = p0, p1 = p1, R = R)
  X_exp <- matrix(c(1, 2, 0, 0, 0,
                    0, 0, 1, 3, 2,
                    1, 4, 0, 0, 0),
                  nrow = 3, byrow = TRUE)
  expect_equal(X_true, X_exp)
})

test_that("z should be numeric", {
  expect_error(hystar_sim(z = "hi", r = c(1, 2), d = 1, phi_R0 = 1, phi_R1 = 1),
               "numeric")
})

test_that("zero or negative residual variances are not allowed", {
  expect_error(check_resvar(c(0, 2)))
})

test_that("there should be 2 resvars", {
  expect_error(check_resvar(c(0, 2, 1)))
})

test_that("Thresholds should be within the range of z.", {
  expect_error(hystar_sim(z = 1:10, r = c(1, 4), d = 1,
                          phi_R0 = 1, phi_R1 = 2),
               "inside the range of `z`")
})

test_that("Delay or regime order cannot be too large", {
  expect_error(hystar_sim(z = 1:3, r = c(2, 2.2), d = 3,
                          phi_R0 = 1, phi_R1 = 2),
               "than the length of `z`")
  expect_error(hystar_sim(z = 1:3, r = c(2, 2.2), d = 1,
                          phi_R0 = 1, phi_R1 = c(0, .1, .1, .1)),
               "than the length of `z`")
})

test_that("unit root or explosive simulation throws warning", {
  expect_warning(check_phi(c(0, .8, .2), R01 = 1), "unit root")
  expect_warning(check_phi(c(0, .8, .3), R01 = 1), "explosive")
})

test_that("you cannot request too many switches", {
  expect_error(z_sim(n_t = 20, n_switches = 20, start_regime = 1))
})

test_that("When z is simulated with hysteresis,
          a certain start will raise an error", {
  z <- z_sim(100, 5, start_regime = 0, start_hyst = TRUE)

  expect_error(hystar_sim(z = z, r = c(-.9, -.8), d = 1, phi_R0 = 0, phi_R1 = 0,
                          resvar = c(1, 1)), "an hysteretic start")
})

test_that("When z is not simulated, and there is no hysteresis,
          starting regime gives warning if it does not match", {
  z <- 1:10
  expect_warning( # r makes start regime certainly 0
    s <- hystar_sim(z = z, r = c(2, 4), d = 1, phi_R0 = 0, phi_R1 = 0,
                    start_regime = 1),
    "`start_regime` is different from what is implied"
    )
  expect_equal(s$data$R[1], 0)

  expect_warning( # r makes start regime certainly 0
    s <- hystar_sim(z = z, r = c(2, 4), d = 1, phi_R0 = 0, phi_R1 = 0,
                    start_regime = 0),
    NA
  )
  expect_equal(s$data$R[1], 0)
})

test_that("When z is not simulated, and there is hysteresis,
          starting regime must be provided.", {
  z <- c(5, 1:10)
  s <- hystar_sim(z = z, r = c(2, 8), d = 1, phi_R0 = 0, phi_R1 = 0,
                  start_regime = 1)
  expect_equal(s$data$R[1], 1)

  expect_error(hystar_sim(z = z, r = c(2, 8), d = 1, phi_R0 = 0, phi_R1 = 0),
               "`start_regime` was not provided")
})

test_that("start check will return inferred start if incorrect start was provided,
          and warn that start_regime was ignored", {
  expect_warning(start <- check_hystar_sim_input(z = 1:5, r = c(2, 3), d = 1,
                                  phi_R0 = 0, phi_R1 = 0, resvar = c(1, 1),
                                  start_regime = 9)$start
  )
  expect_equal(start, 0)
})

test_that("start_hyst must be TRUE or FALSE", {
  expect_error(check_start_hyst(NA), "TRUE or FALSE")
  expect_error(check_start_hyst("a"), "TRUE or FALSE")
})

test_that("range input must be valid", {
  expect_error(z_sim(100, 4, 1, FALSE, c(3, 1), "not larger than the first"))
  expect_error(z_sim(100, 4, 1, FALSE, 3, "a vector of length 2"))
})

test_that("p options are correct", {
  p <- create_p_options(p0 = c(1, 3), p1 = c(2, 4))
  e <- matrix(c(1, 2, NA, NA, NA, NA, NA,
                1, 4, NA, NA, NA, NA, NA,
                3, 2, NA, NA, NA, NA, NA,
                3, 4, NA, NA, NA, NA, NA),
              ncol = 7, byrow = TRUE)
  colnames(e) <- c("p0", "p1", "d", "r0", "r1", "s", "ic")

  expect_equal(p, e)
})

test_that("a vector for r must be of correct length (2)", {
  expect_error(check_r_fit(r = 1:3), "its length must be 2")
})

test_that("a matrix for r must have correct thresholds", {
  r <- matrix(c(1, 2,
                2, 1),
              nrow = 2, byrow = TRUE)
  expect_error(check_r_fit(r), "The second threshold value should")
})

test_that("a matrix for r must have correct dimensions (n by 2)", {
  r <- matrix(c(1, 2, 5,
                2, 1, 1),
              ncol = 3, byrow = TRUE)
  expect_error(check_r_fit(r), "columns")
})

test_that("`r` must be valid quantiles", {
  expect_error(check_rz(r = c(.2, 3),
                        z = 1), "so the values of")
})

test_that("thin must be TRUE or FALSE", {
  expect_error(check_thin("a"), "TRUE or FALSE")
})

test_that("p_select must be a valid choice", {
  expect_error(hystar_fit(data.frame(y = 1:10, z = 1:10), p_select = 1),
               "character")
  expect_error(hystar_fit(data.frame(y = 1:10, z = 1:10), p_select = "bla"),
               "aic")
  p_select <- check_hystar_fit_input(
    z = 1:4, d = 1, p0 = 1, p1 = 1,
    p_select = "aic", r = c(.8, .9), thin = TRUE, tar = FALSE
    )
  expect_equal(p_select, "aic")
})


test_that("`z` must have at least three levels.", {
  expect_error(hystar_fit(data.frame(y = 1:10,
                                     z = c(rep(3, 5), rep(4, 5))
                                     )
                          ), "unique values")
})

test_that("y_eff and z_del are equally long", {
  y <- 1:100
  d <- c(2, 3, 5)
  p0 <- 3
  p1 <- 2
  eff <- time_eff(y, d, p0, p1)
  del <- time_del(y, d, p0, p1, d_sel = 3)
  expect_equal(length(eff), length(del))
})

test_that("number of effective obs is correct", {
  eff <- time_eff(1:100, d = 3, p0 = 5, p1 = 2)
  expect_equal(length(eff), 95)
})

test_that("lagged observations are correct", {
  x1 <- lag_obs(y = 1:10, t = 4, p = 3)
  expect_equal(x1, c(1, 3, 2, 1))

  # Edge case with zero order process.
  x2 <- lag_obs(y = 1:10, t = 4, p = 0)
  expect_equal(x2, 1)
})

test_that("order is correct", {
  order <- get_order(coe = c(0, .4, .5))
  expect_equal(order, 2)

  order <- get_order(coe = c(0, .5, 0, 0))
  expect_equal(order, 1)

  order <- get_order(coe = c(0, 0, 0, 0))
  expect_equal(order, 0)
})

test_that("Trailing zeros are correctly removed.", {
  # Note that by default we want to keep the first value,
  # regardless of its value!
  expect_equal(remove_trailing_zeros(c(1, 2, 0, 0)),
               c(1, 2))

  expect_equal(remove_trailing_zeros(c(0, 0, 1, 3)),
               c(0, 0, 1, 3))

  expect_equal(remove_trailing_zeros(c(0, 0, 0, 0)),
               0)
})

test_that("z buffer is correctly removed, d > p.", {
  z <- z_sim(n_t = 50, n_switches = 3, start_regime = 1, start_hyst = TRUE)
  z_r <- remove_z_buffer(z, d = 3, p0 = 1, p1 = 2)
  expect_equal(z_r[1], 0)
  expect_equal(z_r[1:50], z[11:60])
})

test_that("z buffer is correctly removed, d < p.", {
  z <- z_sim(n_t = 50, n_switches = 3, start_regime = 1, start_hyst = FALSE)
  z_r <- remove_z_buffer(z, d = 2, p0 = 1, p1 = 5)
  expect_equal(z_r[5 + 1 - 2], 1)
})

test_that("z buffer removal keeps original attributes.", {
  z <- z_sim(30, 5, 1)
  z_r <- remove_z_buffer(z, d = 2, p0 = 2, p1 = 1)

  expect_equal(attributes(z), attributes(z_r))
})

test_that("whole numbers are correctly checked", {
  expect_true(is_whole(5))
  expect_false(is_whole(pi))
})

test_that("negative whole numbers raise error", {
  expect_error(check_whole_nn(-5))
})

test_that("whole error has correct variable name", {
  hey <- 4.4
  expect_error(error_whole(hey), "`hey` must be a whole number")
})

test_that("numeric error has correct variable name", {
  hey <- TRUE
  expect_error(error_numeric(hey), "`hey` must be numeric")
})

test_that("nonnegative error has correct variable name", {
  hey <- -9
  expect_error(error_nonnegative(hey), "`hey` must be nonnegative")
})

test_that("r with the smallest distance is selected", {
  optims <- matrix(c(1, 1, 2, 0,
                     1, 1, 3, 0),
                   nrow = 2, byrow = TRUE)
  colnames(optims) <- c("d", "r0", "r1", "s")

  expected <- matrix(c(1, 1, 2, 0),
                     nrow = 1, byrow = TRUE)
  colnames(expected) <- c("d", "r0", "r1", "s")

  expect_equal(select_r(optims), expected)
})

test_that("minimal delay is selected", {
  optims <- matrix(c(2, 1, 2, 0,
                     1, 1, 3, 0),
                   nrow = 2, byrow = TRUE)
  colnames(optims) <- c("d", "r0", "r1", "s")

  expected <- matrix(c(1, 1, 3, 0),
                     nrow = 1, byrow = TRUE)
  colnames(expected) <- c("d", "r0", "r1", "s")

  expect_equal(select_min_d(optims), expected)
})

test_that("search grid for r is correct", {
  z <- 1:3
  grid_r_actual <- create_grid_r(z, r = c(0, 1), thin = FALSE, tar = FALSE)
  grid_r_expected <- matrix(c(1.5, 2.5,
                              1.5, 1.5,
                              2.5, 2.5),
                            ncol = 2, byrow = TRUE)

  expect_equal(grid_r_actual, grid_r_expected)
})

test_that("d is correctly added", {
  grid <- matrix(nrow = 2, ncol = 2)
  grid_d_expected <- cbind(rep(c(1, 3), each = 2),
                           matrix(nrow = 4, ncol = 2))
  grid_d_actual <- add_d(d = c(1, 3), grid)

  expect_equal(grid_d_actual, grid_d_expected)
})

test_that("starts are correct", {
  y <- numeric(50)
  r0 <- 2
  r1 <- 4

  # When delay is larger than max order
  # (straightforward case, because you just look at first value of z)
  d <- 4
  eff <- time_eff(y, d, p0 = 1, p1 = 3) # returns 5, 6, ..., 50

  expect_equal(object = get_start(c(d, r0, r1), z = c(1, 3, 3, 3, 1), eff),
               expected = 0L)

  expect_equal(object = get_start(c(d, r0, r1), z = c(5, 3, 5, 3, 1), eff),
               expected = 1L)

  expect_equal(object = get_start(c(d, r0, r1), z = c(3, 5, 5, 5, 5), eff),
               expected = -1L)

  # When delay is smaller than max order
  # z contains observations at start that can inform about the first regime
  d <- 1
  eff <- time_eff(y, d, p0 = 1, p1 = 4) # returns 5, 6, ..., 50

  expect_equal(object = get_start(c(d, r0, r1), z = c(1, 3, 3, 3, 3), eff),
               expected = 0L)

  # Start is immediately known
  expect_equal(object = get_start(c(d, r0, r1), z = c(5, 3, 3, 1, 1), eff),
               expected = 0L)

  expect_equal(object = get_start(c(d, r0, r1), z = c(3, 3, 3, 3, 3), eff),
               expected = -1L)
})

test_that("z values are correct (with no thinning)", {
  z <- 1:10
  z_values <- get_z_values(z, r = c(.1, .9), thin = FALSE)
  expect_equal(z_values, seq(2.5, 8.5, 1))
})

test_that("intercept string is correct", {
  expect_equal(get_string_intercept(-3), "- 3 ")
  expect_equal(get_string_intercept(3), "3 ")
  expect_equal(get_string_intercept(0), "")
})

test_that("printed formula of AR process is correct", {
  expect_equal(make_formula(coe = c(-2, 4, 0, 1, -5), rv = 1),
               "- 2 + 4 y[t-1] + y[t-3] - 5 y[t-4] + e[t]")

  expect_equal(make_formula(coe = c(0, 0, 0, 0, 1), rv = 1),
               "y[t-4] + e[t]")

  expect_equal(make_formula(coe = c(0, 2, 0, -1, 2), rv = 2),
               "2 y[t-1] - y[t-3] + 2 y[t-4] + 2 e[t]")

  expect_equal(make_formula(coe = c(0), rv = 1),
               "e[t]")
})

test_that("summary and print do not return something", {
  z <- z_sim(n_t = 200, n_switches = 3,
             start_regime = 1, start_hyst = TRUE,
             range = c(-1, 1))
  sim <- hystar_sim(z = z, r = c(-.5, .5), d = 5,
                    phi_R0 = c(0, .6), phi_R1 = c(1. -.3),
                    resvar = c(1, .9),
                    start_regime = 1)
  fit <- hystar_fit(sim$data)

  expect_equal(summary(sim), NULL)
  expect_equal(summary(fit), NULL)
  expect_equal(print(sim), NULL)
  expect_equal(print(fit), NULL)
})

test_that("switch points are correct", {
  R <- c(0, 1, 1, 0, 1, 0, 0, 0, 1)
  exp <- c(2, 4, 5, 6, 9)
  expect_equal(get_sw_pnts(R), exp)
})

test_that("switch point matrix is correct. Start 1, uneven switches", {
  # switch points should be 2 3 4.
  R <- c(1, 0, 1, 0, 0)
  exp_mat <- matrix(c(1, 2,
                      3, 4),
                    ncol = 2, byrow = TRUE)
  expect_equal(get_sw_pnts_mat(R), exp_mat)
})

test_that("switch point matrix is correct. Start 1, even switches", {
  # switch points should be 2 3 4 5.
  R <- c(1, 0, 1, 0, 1, 0)
  exp_mat <- matrix(c(1, 2,
                      3, 4,
                      5, 6), # 6 is the last time point
                    ncol = 2, byrow = TRUE)
  expect_equal(get_sw_pnts_mat(R), exp_mat)
})

test_that("switch point matrix is correct. Start 0, uneven switches", {
  # switch points should be 2 3 4.
  R <- c(0, 1, 0, 1, 1, 1)
  exp_mat <- matrix(c(2, 3,
                      4, 6), # 6 is the last time point
                    ncol = 2, byrow = TRUE)
  expect_equal(get_sw_pnts_mat(R), exp_mat)
})

test_that("switch point matrix is correct. Start 0, even switches", {
  # switch points should be 2 3 4 5.
  R <- c(0, 1, 0, 1, 0, 0)
  exp_mat <- matrix(c(2, 3,
                      4, 5),
                    ncol = 2, byrow = TRUE)
  expect_equal(get_sw_pnts_mat(R), exp_mat)
})

test_that("plot function does not return", {
  z <- z_sim(n_t = 50, n_switches = 3,
             start_regime = 1, start_hyst = TRUE,
             range = c(-1, 1))
  sim <- hystar_sim(z = z, r = c(-.5, .5), d = 5,
                    phi_R0 = c(0, .6), phi_R1 = c(1. -.3),
                    resvar = c(1, .9),
                    start_regime = 1)
  fit <- hystar_fit(sim$data)

  expect_equal(plot(sim), NULL)
  expect_equal(plot(fit), NULL)
})

test_that("hysteretic time series is correct", {
  actual   <- ts_hys(z = c(3, 1, 3, 5, 3), r0 = 2, r1 = 4)
  expected <- as.integer(c(-1, 0, -1, 1, -1))
  expect_equal(actual, expected)

  not_expected <- c(-1, 0, -1, 1, -1) # double
  !expect_equal(actual, not_expected)
})

test_that("regime time series is correct", {
  actual   <- ts_reg(as.integer(c(1, -1, 0, -1, 1)))
  expected <- as.integer(c(1, 1, 0, 0, 1))
  expect_equal(actual, expected)

  actual   <- ts_reg(as.integer(c(-1, 1, -1, 0, -1)), start = 0)
  expected <- as.integer(c(0, 1, 1, 0, 0))
  expect_equal(actual, expected)
})

z <- z_sim(n_t = 200, n_switches = 4, start_regime = 1)
sim <- hystar_sim(z = z, r = c(-.5, .5), d = 1,
                  phi_R0 = c(0, .4), phi_R1 = c(1, .5))
fit <- hystar_fit(sim$data)

test_that("coef method output has correct dimensions", {
  expect_equal(dim(coef(fit)), c(2, 2))
})

test_that("residuals and fitted values have correct length", {
  expect_equal(length(residuals(fit)), 199)
  expect_equal(length(fitted(fit)), 199)
})

test_that("confint method output has correct dimensions", {
  # Suppress warning about negative variances of estimators.
  suppressWarnings({
    expect_equal(dim(confint(fit)), c(4, 2))
  })
})

test_that("n obs is correct", {
  e <- c(199, sum(1 - fit$data$R, na.rm = TRUE), sum(fit$data$R, na.rm = TRUE))
  names(e) <- c("used", "regime0", "regime1")
  expect_equal(nobs(fit), e)
})

test_that("one step AR simulation has correct length", {
  y <- AR(x = 1:2, coe = c(0, .5), resvar = 1)
  expect_equal(length(y), 1)
})

test_that("burn-in samples has correct length", {
  y <- create_burn_in(50, c(0, .5), 1)
  expect_equal(length(y), 50)
})

test_that("y simulation has correct length", {
  R <- c(rep(0, 10), rep(1, 10))
  y <- y_sim(R, phi_R0 = 0, phi_R1 = 1, resvar = c(1, 1))
  expect_equal(length(y), 20)
})

test_that("sine/cosine simulation starts at right place", {
  z <- simulate_cossin(n_t = 3, n_switches = 1,
                       start_regime = 0, start_hyst = FALSE)
  expect_equal(z[11], -1) # There is a buffer of 10

  z <- simulate_cossin(n_t = 3, n_switches = 1,
                       start_regime = 1, start_hyst = FALSE)
  expect_equal(z[11], 1)

  z <- simulate_cossin(n_t = 3, n_switches = 1,
                       start_regime = 0, start_hyst = TRUE)
  expect_equal(z[11], 0)
})

test_that("z range is right", {
  z <- z_sim(n_t = 200, n_switches = 2, start_regime = 1, range = c(3, 8))
  expect_equal(min(z), 3)
  expect_equal(max(z), 8)
})
